class StructError(Exception):
    pass


class Struct(object):
    """
    generate a class representing a struct
    """
    def get_buffer(self):
        """
        generate a buffer of the struct
        :return: a packed buffer
        :rtype: C{bytes}
        """
        raise NotImplementedError()

    def read_buffer(self, buffer):
        """
        read the struct fields from a buffer
        :param buffer: buffer to read
        :type buffer: C{bytes}
        """
        raise NotImplementedError()

    def get_buffer_size(self):
        """
        :return: the size of the buffer that would be generated by get_buffer
        :rtype: C{int}
        """
        raise NotImplementedError()

    def __eq__(self, other):
        return type(self) == type(other) and self.get_buffer() == other.get_buffer()
